package com.sun.org.apache.xerces.internal.impl.xs.util;

import com.sun.org.apache.xerces.internal.impl.xs.XSModelImpl;
import com.sun.org.apache.xerces.internal.impl.xs.SchemaGrammar;
import java.util.ArrayList;
import com.sun.org.apache.xerces.internal.xs.XSModel;
import com.sun.org.apache.xerces.internal.util.XMLGrammarPoolImpl;

public class XSGrammarPool extends XMLGrammarPoolImpl
{
    public XSGrammarPool() {
    }
    
    public XSModel toXSModel() {
        return this.toXSModel((short)1);
    }
    
    public XSModel toXSModel(short schemaVersion) {
        ArrayList<XMLGrammarPoolImpl.Entry> list = new ArrayList();
        for (int i = 0; i < this.fGrammars.length; ++i) {
            for (XMLGrammarPoolImpl.Entry entry = this.fGrammars[i]; entry != null; entry = entry.next) {
                if (entry.desc.getGrammarType().equals("http://www.w3.org/2001/XMLSchema")) {
                    list.add(entry.grammar);
                }
            }
        }
        int size = list.size();
        if (size == 0) {
            return this.toXSModel(new SchemaGrammar[0], schemaVersion);
        }
        SchemaGrammar[] gs = (SchemaGrammar[])(SchemaGrammar[])list.toArray(new SchemaGrammar[size]);
        return this.toXSModel(gs, schemaVersion);
    }
    
    protected XSModel toXSModel(SchemaGrammar[] grammars, short schemaVersion) {
        return new XSModelImpl(grammars, schemaVersion);
    }
}
